package commun;

import java.util.ArrayList;
import java.util.Collection;


public class Coordonnees {
	private int I;
	private int J;

	    public Coordonnees(int i, int j) {
	        this.I = i;
	        this.J = j;
	    }

	    public boolean equals(Coordonnees c) {
	        return (this.I == c.getI() && this.I == c.getI());
	    }

	    public int getI() {
	        return this.I;
	    }

	    public int getJ() {
	        return this.J;
	    }
	    /**
	     * Nombre de cases entre this et le bord gauche du plateau
	     * @param p
	     * @return
	     */
	    public int distBordG(Plateau p){
		    	return 1+(this.getJ()-1);
	    }

	    /**
	     * Nombre de cases entre this et le bord droit du plateau
	     * @param p
	     * @return
	     */
	    public int distBordD(Plateau p){
		    	return p.width()- this.getJ()-1;
	    }
	    
	    /**
	     * Retourne les coordonnées de la postion adjacente à celle-ci dans la direction
	     * donnée par d.
	     * @param d
	     * @return
	     */
	   public Coordonnees adjacente(Direction d){
		   switch (d){
			case N : return new Coordonnees(this.I-1, this.J);
			case S : return new Coordonnees(this.I+1, this.J);
			case E : return new Coordonnees(this.I, this.J+1);
			case O : return new Coordonnees(this.I, this.J-1);
			case NE: return new Coordonnees(this.I-1, this.J+1);
			case NO: return new Coordonnees(this.I-1, this.J-1);
			case SE: return new Coordonnees(this.I+1, this.J+1);
			case SO: return new Coordonnees(this.I+1, this.J+1);
			}
			throw new IllegalArgumentException();		
		}   
	   /**
		 * Retourne une collection contenant toutes les positions se trouvant
		 * dans un segment qui part de this dans la direction d et qui a une taille dist.
		 * @param dist
		 * @param d
		 * @return
		 */
		public ArrayList<Coordonnees> segment(int dist, Direction d){
			ArrayList<Coordonnees> points= new ArrayList<Coordonnees>();
			Coordonnees p=this;
			for (int i=1; i<=dist; i++){
				p=p.adjacente(d);
				points.add(p);
			}
			return points;
		}
		/**
		 * Retourne le segment de points contenant cette position et toutes celles
		 * à sa gauche et à sa droite pour les distances 
		 * @param distG
		 * @param distD
		 * @return
		 */
		public ArrayList<Coordonnees> horizontal(int dg, int dd){
			ArrayList<Coordonnees> points= this.segment(dg, Direction.O);
			points.add(this);
			ArrayList<Coordonnees> pointsD= this.segment(dd, Direction.E);
			points.addAll(pointsD);
			return points;
		}			
	}
	

