package commun;


/**
 * <code>PieceVide</code> est une implantation de l'interface
 * <code>Piece</code> représentant une case vide. 
 *
 * @author Pierre.Courtieu 
 */
public class PieceVide /*extends PieceAbstraite*/ implements Piece {
    public class PieceVideException extends RuntimeException{}
    
    protected Coordonnees position; // position dans son plateau
    protected Plateau tableau;      // Une pièce connait son plateau
    protected Character charname;   // Caractère pour afficher la pièce.


    public PieceVide(Coordonnees c, Plateau t) {
        this.position = c;
        this.tableau = t;
        this.charname = ' ';
        t.setPiece(c, this);
    }

    public PieceVide(int i, int j, Plateau t) {
        this.position = new Coordonnees(i, j);
        this.tableau = t;
        this.charname = ' ';
        t.setPiece(i, j, this);
    }

    public boolean estVide() {
        return true;
    }

    public boolean estGagnant() {
        throw (new PieceVideException());
    }


    public Character getName() {
        return new Character(' ');
    }

	@Override
	public Coordonnees getPosition() {
		return this.position;
	}

	@Override
	public boolean peutSePlacerA(Coordonnees c) {
		throw (new PieceVideException());
	}

	@Override
	public void place(Coordonnees c) {
		throw (new PieceVideException());
		
	}

	@Override
	public void supprime() {
		throw (new PieceVideException());
		
	}

	@Override
	public boolean sameName(Piece p) {
		return p.getName()==this.getName();
	}
}
