package commun;

public class Plateau {

	private Piece[][] plateau; // Les pièces du plateau, une piece vide pour les case vide.

	/**
	 * Construit un tableau rempli de cases vides ({@code PieceVide}) de
	 * largeur {@code width} et de hauteur {@code height}.
	 * @param width largeur du tableau
	 * @param height hauteur du tableau
	 */
	public Plateau (int width, int height){
		Piece[][] t = new Piece[width][height];
		this.plateau = t;
		for(int i = 0; i< width; i++){
			for(int j = 0; j< height; j++){
				System.out.println("i,j= " +i +" , " + j);
				t[i][j]=new PieceVide(i,j,this); 
			}
		}
	}
	/** {@code iop.contient(c)} retourne true si la coordonnee 
	 *  {@code c} est dans les limites du plateau
	 */
	public boolean contient (Coordonnees c){
		return  (c.getI() >= 0 && c.getI() < width() && 
				c.getJ() >= 0 && c.getJ() < height());
	}

	/** {@code iop.getPiece(c)} retourne la pi�ce situ�e � la coordonn�e
	 * {@code c} dans {@code iop}. */
	public Piece getPiece(Coordonnees c) {
		return this.plateau[c.getI()][c.getJ()];
	}

	/** {@code iop.getPiece(x,y)} retourne la piece situee à la coordonnée
	 *  {@code x,y} dans {@code iop}. */
	public Piece getPiece(int x, int y) {
		return this.plateau[x][y];
	}


	/**
	 * {@code iop.setPiece(c,p)} positionnne la pièce {@code p} à la coordonnée
	 * {@code c} sur le plateau de {@code iop}.
	 * @param c la coordonnée de la case à remplir
	 * @param p la pièce à mettre
	 */

	public void setPiece(Coordonnees c, Piece p) {
		this.plateau[c.getI()][c.getJ()] = p;
	}

	/**
	 * {@code iop.setPiece(x,y,p)} positionnne la pièce {@code p} à la coordonnée
	 * {@code x,y} sur le plateau de {@code iop}.
	 * @param c la coordonnée de la case à remplir
	 * @param p la pièce à mettre
	 */
	public void setPiece(int x, int y, Piece p) {
		this.plateau[x][y] = p;
	}

	/**
	 * {@code p.width()} retourne la largeur du plateau de {@code p}.
	 * @return la largeur du plateau
	 */
	public int width(){
		return this.plateau.length;
	}

	/**
	 * {@code p.height()} retourne la hauteur du plateau de {@code p}.
	 * @return la hauteur du plateau
	 */
	public int height(){
		return this.plateau[0].length;
	}

	/** Calcul des pièces se trouvant sur les bords du plateau */

	/** Pièce se trouvant dans le coin en haut à gauche du plateau
	 * 
	 * @return Piece
	 */
	public Piece coinHG(){
		return getPiece(0,0);
	}

	/** Affiche le plateau 
	 * 
	 */
	public void afficher(){
		String trait = "";
		for (int i= 1; i <= width(); i++){
			trait = trait + " ___";
		}
		System.out.println();
		System.out.println(trait);
		for (int y = height()-1; y >=0; y--){
			System.out.print("| ");
			for (int x = 0; x < width(); x++){
				System.out.print(getPiece(x,y).getName() + " | ");
			}
			System.out.println();
			System.out.println(trait);
		}
	}
}

